#include<i2c.h>
void i2c_int(void)
{
	P_SW2=0x80;//enable visit XFR,select P14 and P15 as I2C PIN
	I2CCFG=0xda;//enable I2C function,enable I2C host mode,set I2C bus speed is 100k/s
	I2CMSST=0x00;//clear I2C interrupt flag bit
}
void wait(void)
{
	while(!(I2CMSST&0x40));//I2C Operation completion flag bit,bit 6 is flag bit 
	I2CMSST&=~0x40;//I2CMSST BIT 6 is 0,other bits is 1
}
void start(void)
{
	I2CMSCR=0x01;//send start command,close host mode interruput
	//I2CMSCR=0x81;//send start command,enable host mode interruput
	wait();
}
void writebyte(uchar dat)
{
	I2CTXD=dat;//write data to data buffer zone
	I2CMSCR=0x02;//send data command,close host mode interruput
	//I2CMSCR=0x82;//send data command,enable host mode interruput
	wait();
}
void recvack(void)
{
	I2CMSCR=0x03;//send read ack command,close host mode interruput
	//I2CMSCR=0x83;//send read ack command,enable host mode interruput
	wait();
}
char recvdata(void)
{
	I2CMSCR=0x04;//send recv command,close host mode interruput
	//I2CMSCR=0x84;//send recv command,enable host mode interruput
	wait();
	return I2CRXD;
}
void sendack(void)
{
	I2CMSST=0x00;//set ack signal
	I2CMSCR=0x05;//send ack command,close host mode interruput
	//I2CMSCR=0x85;//send ack command,enable host mode interruput
	wait();
}
void sendnak(void)
{
	I2CMSST=0x01;//set nak signal
	I2CMSCR=0x05;//send ack command,close host mode interruput
	//I2CMSCR=0x85;//send ack command,enable host mode interruput
	wait();
}
void stop(void)
{
	I2CMSCR=0x06;//send stop command,close host mode interruput
	//I2CMSCR=0x86;//send stop command,enable host mode interruput
	wait();
}
void write_data(uchar add,uchar dat)
{
	start();//send start command
	writebyte(0x0c);//send device address+write command
	recvack();     //0x0c is SY8801 write address
	writebyte(add);//charge and discharge enable register address
	recvack();
	writebyte(dat);//write  data to 0x31 register 
	recvack();
	stop();//send stop command
}
uchar read_data(uchar add)
{
	uchar date;
	start();//send start command
	writebyte(0x0C);//send device address+write command
	recvack();
	writebyte(add);//send register address 
	recvack();
	start();//send start command
	writebyte(0x0D);//send device address+read command
	recvack();
	date=recvdata();//read data 1
//	sendack();
//	P2=recvdata();//read data 2
	sendnak();
	stop();//send stop command
	return date;
}
